_nrandom2 		PROTO :DWORD		; random-algo from MASM-Package
_addStar		PROTO :DWORD,:DWORD,:DWORD

StarsF STRUCT	; contains basic parameters for stars
	dwXPos	DWORD ?		; Horizontal position in screen-coodinates
	dwYPos	DWORD ?		; Vertical position in screen-coodinates
	dwZPos	DWORD ?		; Initial Distance
	dwXMov	DWORD ?		; xPos movement
	dwYMov	DWORD ?		; yPos movement
	dwColor	DWORD ?		; color
StarsF ends

.CODE

; -------------------------------------------------------------------------

TimerProc proc hWnd:DWORD, uMsg:DWORD, idEvent:DWORD, dwTime:DWORD

Local bmpData:BitmapData 	; structure filled by BitmapLockBits API
Local x1:DWORD
Local y1:DWORD
Local x2:DWORD
Local y2:DWORD

	mov eax,rct.right					; calculate the center of the client rect,
	mov ecx,rct.bottom				;  odd numbers are ignored
	push eax
	push ecx
	shr eax,1
	shr ecx,1
	add eax,udwXoff					; add center offset to
	add ecx,udwYoff					;  simulate different viewing directions
	mov udwCWidth,eax
	mov udwCHeight,ecx
	pop ecx
	pop eax
	
; ----retrieve access to modify bitmap bits directly - 32bpp
	Invoke GdipBitmapLockBits,hBitmap,DWORD PTR rct,ImageLockModeWrite,PixelFormat32bppARGB,ADDR bmpData

	push esi

	sub rct.right,3					; prevent from drawing 
	sub rct.bottom,3					;  outside of the bitmap

	mov esi,ptrStarTable
	mov ecx,numStars
	.WHILE ecx > 0
		push ecx
		
; --------- calculate distance of star
		mov ecx,[esi+8]				; zPos	
		sub ecx,udwSpeed				; calculate new distance
		.if ecx < udwPanel			; is star nearer than panel?
			invoke _addStar,esi,hWnd,1	; if so, replace with new star
		.elseif
			mov [esi+8],ecx			; if not, store new distance
		.endif
		
; --------- calculate position of star
		finit
		push 	eax
		fild 	DWORD PTR [esi]			; xPos
		fisub	DWORD PTR udwCWidth		; correct offset
		fimul	DWORD PTR udwPanel		; calculate drifting with help of virtual panel
		fidiv	DWORD PTR [esi+8]		      ; divide by distance
		fistp	DWORD PTR [esp]			; store result as integer and pop FPU-Stack
		pop 	eax
		cmp 	eax,DWORD PTR [esi+12]	      ; check if we have a new position
		je	_nochange
		push 	eax
		sub	eax,DWORD PTR [esi+12]	      ; get the movement
		add 	[esi],eax				; and add it to current position
		pop 	eax						
		mov	[esi+12],eax			; store x-movement for further comparison
_nochange:
		push 	eax
		fild 	DWORD PTR [esi+4]		      ; yPos
		fisub	DWORD PTR udwCHeight	      ; do the same as above with y-value
		fimul	DWORD PTR udwPanel
		fidiv	DWORD PTR [esi+8]
		fistp	DWORD PTR [esp]
		pop 	eax
		cmp 	eax,DWORD PTR [esi+16]
		je		_nochange1
		push 	eax
		sub		eax,DWORD PTR [esi+16]
		add 	[esi+4],eax
		pop 	eax
		mov		[esi+16],eax		; store y-movement for further comparison
_nochange1:
		
		mov ecx,[esi]				; get new xPos
		mov eax,[esi+4]				; get new yPos
		
; --------- prevent from drawing if we are outside of the bitmap
		.if (ecx >= rct.right) || (eax >= rct.bottom)
			jmp _next
		.endif
		
; --------- CALCULATE ADDRESS OF PIXEL TO MODIFY: [Scan0+(y * stride)+(x*4)]
		shl ecx,2						; (x*4)
		mul bmpData.stride				; (y * stride) 
		add ecx,bmpData.scan0			; [Scan0+(x*4)]
		mov edx,[esi+20]				; Color to draw
		add eax,ecx						; [Scan0+(y * stride)+(x*4)]
		mov ecx,[esi+8]					; get new distance to determine stars size

		push edi
		mov edi,bmpData.stride
		
		mov [eax],edx				; draw 1 pixel always
		.if ecx < 3000
			mov [eax+4],edx			; draw 2 pixel [1*2]
		.endif
		.if ecx < 2000
			;add eax,edi
			mov [eax+edi],edx		; draw 4 pixel [2*2]
			mov [eax+edi+4],edx
		.endif
		.if ecx < 1000				; draw 9 pixel [3*3]
			mov [eax+8],edx
			mov [eax+edi+8],edx
			mov [eax+edi*2],edx
			mov [eax+edi*2+4],edx
			mov [eax+edi*2+8],edx
		.endif
		pop edi
_next:
		add esi,24					; base address of next star structure
		pop ecx
		dec ecx
	.ENDW

	add rct.right,3						; prevent from drawing 
	add rct.bottom,3					;  outside of the bitmap

	pop esi	
	
	Invoke GdipBitmapUnlockBits,hBitmap,ADDR bmpData

; --- DRAW A SAMPLE TEXT: SPEED	
	mov eax,udwSpeed				; load speed to eax
	Invoke dwtoa,eax,ADDR szBuf		; convert to ascii

; --- get ascii string length in ecx and convert to unicode
	lea edx,szBuf				
	xor ecx,ecx					; initialize counter
	mov al,[edx]				; get first character
@@:
	cmp al,0					; String end?
	je @F						; if so => ready
	push edx
	lea edx,wText				; address of unicode text
	add edx,14					; add offset of first character to write
	mov [edx+ecx*2],al			; write character
	pop edx
	add ecx,1					; increase counter
	mov al,[edx+ecx]			      ; get next character
	jmp @B					; continue
@@:	
	add ecx,7
; --- draw string
	Invoke GdipDrawString, hGraphics2,ADDR wText,ecx,hCurFont,ADDR rctF,0,hBrush
	
; --- DRAW NAVIGATION CROSS 10*10
	mov ecx,udwCWidth				; get center xPos
	mov eax,udwCHeight			; get center yPos
	sub	ecx,5
	mov x1,ecx
	add ecx,10
	mov x2,ecx
	mov y1,eax
	mov y2,eax
	Invoke GdipDrawLineI,hGraphics2,hPen,x1,y1,x2,y2	; draw horizontal line

	mov ecx,udwCWidth				; get center xPos
	mov eax,udwCHeight			; get center yPos
	sub	eax,5
	mov y1,eax
	add eax,10
	mov y2,eax
	mov x1,ecx
	mov x2,ecx	
	Invoke GdipDrawLineI,hGraphics2,hPen,x1,y1,x2,y2	; draw vertical line

; --- we are ready, draw the image
	Invoke GdipDrawImage,hGraphics,hBitmap,0,0
	
_exit:
	xor eax,eax 
	ret

TimerProc ENDP

; -------------------------------------------------------------------------

_addStar PROC USES esi ptrST:DWORD, hWnd:DWORD, dwStars:DWORD 

Local cRct:RECT
Local bARGB:COLORBYTES

	Invoke GetClientRect,hWnd,ADDR cRct
	mov esi,ptrST
	mov ecx,dwStars
	
	.WHILE ecx > 0
		push ecx
		
		mov eax,cRct.right 			; calculate random xPos
		sub eax,10
		Invoke _nrandom2,eax
		add eax,5
		mov [esi],eax
		
		mov eax,cRct.bottom			; calculate random yPos
		sub eax,10	
		Invoke _nrandom2,eax
		add eax,5						
		mov [esi+4],eax
		
		Invoke _nrandom2,10000			; calculate random zPos (distance)
		add	eax,3000				;	Range: 10000 to 13000
		mov [esi+8],eax
		
		xor eax,eax					; clear old movements
		mov [esi+12],eax
		mov [esi+16],eax	
		
		invoke _nrandom2,192			; calculate random Color (Grayscale)
		add eax,64
		mov bARGB.BlueByte,al
		mov bARGB.GreenByte,al	
		mov bARGB.RedByte,al
		mov bARGB.AlphaByte,0FFh
; --------- Calculate some random blue and yellow stars 
		invoke _nrandom2,3
		.if eax == 0
			invoke _nrandom2,50
			sub bARGB.GreenByte,al
			sub bARGB.RedByte,al
			mov edx,DWORD PTR bARGB
			mov [esi+20],edx				
		.elseif eax == 1
			invoke _nrandom2,30
			sub bARGB.BlueByte,al
			mov edx,DWORD PTR bARGB
			mov [esi+20],edx
		.endif					
		
		add esi,24
		pop ecx
		dec ecx
	.ENDW
	
	xor eax,eax
	RET
	
_addStar ENDP

; -------------------------------------------------------------------------

_KeyProc Proc wParam:DWORD

	MOV EAX,wParam
;---speed control keys
	cmp eax,107 			; [+] on numpad
	jne @F
	mov	ecx,udwSpeed
	cmp ecx,300				; max speed = 300
	jge	_exit
	add	udwSpeed,1			; increase speed
@@: cmp eax,109				; [-] on numpad
	jne @F
	mov	ecx,udwSpeed
	cmp ecx,0				; min speed = 0
	jbe _exit
	sub	udwSpeed,1			; decrease speed
@@:	cmp eax,111				; [/] on numpad
	jne @F
	mov udwSpeed,300		      ; max speed
	jmp _exit
@@:	cmp eax,106				; [*] on numpad
	jne @F
	mov udwSpeed,0			; min speed
	jmp _exit
	
;---direction control keys - arrow keys or numpad
@@:	cmp eax,37 				; [left arrow] on numpad - numlock off
	jne @F				; another key was pressed
	sub udwXoff,4
	jmp _exit				; we've got the key, exit
@@:	cmp eax,100 			; [left arrow] on numpad - numlock on
	jne @F
	sub udwXoff,4	
	jmp _exit
@@:	cmp eax,38 				; [up arrow] on numpad - numlock off
	jne @F
	sub udwYoff,4
	jmp _exit
@@:	cmp eax,104 			; [up arrow] on numpad - numlock on
	jne @F
	sub udwYoff,4
	jmp _exit	
@@:	cmp eax,39 				; [right arrow] on numpad - numlock off
	jne @F
	add udwXoff,4
	jmp _exit
@@:	cmp eax,102 			; [right arrow] on numpad - numlock on
	jne @F
	add udwXoff,4	
	jmp _exit	
@@:	cmp eax,40 				; [down arrow] on numpad - numlock off
	jne @F
	add udwYoff,4
	jmp _exit
@@:	cmp eax,98 				; [down arrow] on numpad - numlock on
	jne @F
	add udwYoff,4	
	jmp _exit
@@:	cmp eax,97 				; [down left] on numpad - numlock on
	jne @F
	add udwYoff,4
	sub udwXoff,4
@@:	cmp eax,35 				; [down left] on numpad - numlock off
	jne @F
	add udwYoff,4
	sub udwXoff,4
	jmp _exit	
@@:	cmp eax,99 				; [down right] on numpad - numlock on
	jne @F
	add udwYoff,4
	add udwXoff,4
	jmp _exit
@@:	cmp eax,34 				; [down right] on numpad - numlock off
	jne @F
	add udwYoff,4
	add udwXoff,4
	jmp _exit	
@@:	cmp eax,103 			; [up left] on numpad - numlock on
	jne @F
	sub udwYoff,4
	sub udwXoff,4
	jmp _exit
@@:	cmp eax,36	 			; [up left] on numpad - numlock off
	jne @F
	sub udwYoff,4
	sub udwXoff,4
	jmp _exit	
@@:	cmp eax,105				; [up right] on numpad - numlock on
	jne @F
	sub udwYoff,4
	add udwXoff,4
	jmp _exit
@@:	cmp eax,33				; [up right] on numpad - numlock off
	jne @F
	sub udwYoff,4
	add udwXoff,4
	jmp _exit	
@@:	cmp eax,101				; [5 center] on numpad - numlock on
	jne @F
	mov udwYoff,0
	mov udwXoff,0
	jmp _exit
@@:	cmp eax,12				; [5 center] on numpad - numlock off
	jne @F
	mov udwYoff,0
	mov udwXoff,0	
@@:
_exit:
	xor eax,eax
	RET
_KeyProc EndP

; -------------------------------------------------------------------------

dwtoa PROC dwValue:DWORD, lpBuffer:DWORD

    ; -------------------------------------------------------------
    ; convert DWORD to ascii string
    ; dwValue is value to be converted
    ; lpBuffer is the address of the receiving buffer
    ; Uses: eax, ecx, edx.
    ; -------------------------------------------------------------

    push ebx
    push esi
    push edi

    mov eax, dwValue
    mov edi, [lpBuffer]

    or eax,eax
    jnz sign

  zero:
    mov word ptr [edi],30h
    ret

  sign:
    jns pos
    mov byte ptr [edi],'-'
    neg eax
    inc edi

  pos:
    mov ecx, 3435973837
    mov esi, edi

    .WHILE (eax > 0)
      mov ebx,eax
      mul ecx
      shr edx, 3
      mov eax,edx
      lea edx,[edx*4+edx]
      add edx,edx
      sub ebx,edx
      add bl,'0'
      mov [edi],bl
      inc edi
    .ENDW

    mov byte ptr [edi], 0       ; terminate the string

    ; We now have all the digits, but in reverse order.

    .WHILE (esi < edi)
      dec edi
      mov al, [esi]
      mov ah, [edi]
      mov [edi], al
      mov [esi], ah
      inc esi
    .ENDW

    pop edi
    pop esi
    pop ebx
    ret

dwtoa ENDP

; -------------------------------------------------------------------------

_nrandom2 PROC base:DWORD
    mov eax, udwSeed
    xor edx, edx

    ; Moved to avoid unnecessary dependency.
    ;****************************************
    test eax, 80000000h
    jz  @F
    add eax, 7fffffffh
  @@:
    ;****************************************

    mov ecx, 127773
    div ecx
    mov ecx, eax
    mov eax, 16807
    mul edx
    mov edx, ecx
    mov ecx, eax
    mov eax, 2836
    mul edx
    sub ecx, eax
    xor edx, edx
    mov eax, ecx
    mov udwSeed, ecx

    ;*******************************
    ;div base
    shl eax,1
    mul base
    ;*******************************

    mov eax, edx
    ret
_nrandom2 ENDP
