; -------------------------------------------------------------------------
; Simple Starfield Simulation
; Dependencies: GDIplus.dll
; coded by Phoenix 2005
; Attention: rookie code - bugs guaranteed!
; -------------------------------------------------------------------------

.386

.MODEL FLAT,STDCALL

OPTION CASEMAP:NONE

; -------------------------------------------------------------------------
Include StarfieldData.inc
Include StarFieldProc.inc

; -------------------------------------------------------------------------
numStars EQU 1750							; CHANGE NUMBER OF STARS HERE
numBytes EQU numStars * SIZEOF StarsF
			; calculate number of bytes to allocate
; -------------------------------------------------------------------------
WinMain 	PROTO :DWORD,:DWORD,:DWORD,:DWORD
TimerProc 	PROTO :DWORD,:DWORD,:DWORD,:DWORD
dwtoa 	PROTO :DWORD,:DWORD			      ; converts DoubleWord to ASCII
_KeyProc 	PROTO :DWORD					; 

; -------------------------------------------------------------------------

.CODE

_InitGdip PROC hWnd:DWORD

; --- initialize graphics and bitmap class
	Invoke GdipCreateFromHWND,hWnd,ADDR hGraphics
; --- get drawable area
	Invoke GetClientRect,hWnd,ADDR rct

	Invoke GdipCreateBitmapFromGraphics,rct.right,rct.bottom,hGraphics,ADDR hBitmap
	Invoke GdipGetImageGraphicsContext,hBitmap,ADDR hGraphics2
	Invoke GdipSetCompositingMode,hGraphics,CompositingModeSourceCopy
	Invoke GdipCreateFontFamilyFromName,ADDR wFontname,0,ADDR hFontFam
	Invoke GdipCreateFont,hFontFam,emSize,FontStyleBold,UnitPixel,ADDR hCurFont
	Invoke GdipCreateSolidFill,ColorsDarkGreen,ADDR hBrush
	Invoke GdipCreatePen1,ColorsDarkGreen,fWidth,UnitPixel,ADDR hPen
	xor eax,eax
	RET
_InitGdip EndP

_CleanUpGdip Proc

	Invoke GdipDeletePen, hPen
	Invoke GdipDeleteBrush,hBrush
	Invoke GdipDeleteFont,hCurFont
	Invoke GdipDeleteFontFamily,hFontFam
	Invoke GdipDeleteGraphics,hGraphics2
	Invoke GdipDisposeImage,hBitmap
	Invoke GdipDeleteGraphics,hGraphics
	xor eax,eax
	RET
_CleanUpGdip EndP

Start:
	Invoke GetModuleHandle, NULL
	MOV hInstance,EAX
	Invoke WinMain, hInstance, NULL, NULL, SW_SHOWDEFAULT
	Invoke ExitProcess,EAX
	
WinMain Proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD

Local wc:WNDCLASSEX
Local msg:MSG
Local hwnd:HWND

; --- Retrieve width and height, in pixels, of the screen.
	Invoke GetSystemMetrics, SM_CXSCREEN
	MOV udwScrSizeX,EAX
	Invoke GetSystemMetrics, SM_CYSCREEN
	MOV	udwScrSizeY,EAX
	
; --- Initialize GDIplus
	Invoke GdiplusStartup,ADDR hGDIplus,ADDR GdiPlusSI,NULL
	.IF eax != 0
		Invoke MessageBox, NULL, ADDR szGDIpInitFail, Offset szAppName, MB_OK OR MB_ICONERROR
		RET
	.ENDIF
	
; --- Fill window class information structure
	MOV wc.cbSize, SizeOf WNDCLASSEX
	MOV wc.style, CS_HREDRAW or CS_VREDRAW or CS_OWNDC 
	MOV wc.lpfnWndProc, Offset WndProc
	MOV wc.cbClsExtra,NULL
	MOV wc.cbWndExtra,NULL
	PUSH hInst
	POP wc.hInstance
	MOV wc.hbrBackground, COLOR_WINDOWTEXT
	MOV wc.lpszMenuName, NULL
	MOV wc.lpszClassName, Offset ClassName
	Invoke LoadIcon, NULL, IDI_WINLOGO	
	MOV wc.hIcon,EAX
	MOV wc.hIconSm,0
	Invoke LoadCursor, NULL, IDC_CROSS
	MOV wc.hCursor,EAX
	
; --- Register window class
	Invoke RegisterClassEx, addr wc
	
; --- Create window (full screen)
	Invoke CreateWindowEx,WS_EX_TOPMOST	,ADDR ClassName,ADDR szAppName,\
            WS_POPUP,0,0,udwScrSizeX,udwScrSizeY,NULL,NULL,\
           hInst,NULL
	MOV hwnd,EAX
	Invoke ShowWindow, hwnd,SW_SHOWNORMAL	;SW_SHOWMAXIMIZED
	Invoke UpdateWindow, hwnd
	.While TRUE
		Invoke GetMessage, ADDR msg, NULL, 0, 0
		.Break .IF (!EAX)
		Invoke TranslateMessage, ADDR msg
		Invoke DispatchMessage, ADDR msg
	.EndW
	MOV EAX, msg.wParam
	RET
WinMain ENDP

WndProc Proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
LOCAL rctT:RECT 
LOCAL ps:PAINTSTRUCT 

	.IF uMsg==WM_DESTROY
; --------- kill the timer
		Invoke KillTimer,hWnd,TimerID
		Invoke _CleanUpGdip
; --------- Shutdown GDIplus.dll
		.IF hGDIplus != 0
			Invoke GdiplusShutdown,hGDIplus
		.ENDIF
; --------- free allocated memory
		.IF ptrStarTable != 0
			Invoke LocalFree,ptrStarTable
		.ENDIF
		Invoke PostQuitMessage, NULL
		
	.ELSEIF uMsg == WM_CREATE
; --------- initialize GDI+ library handles
		invoke _InitGdip,hWnd
; --------- Create a timer
		Invoke SetTimer,hWnd,1,uElapse,ADDR TimerProc
		mov TimerID,eax
; --------- Allocate memory [for StarTable]
		Invoke LocalAlloc,LMEM_FIXED OR LMEM_ZEROINIT,numBytes	; LMEM_FIXED: hMem == ptrMem
		.IF eax != NULL
			mov	ptrStarTable,eax
; --------------- Initialize "Star" Table	
			Invoke _addStar,ptrStarTable,hWnd,numStars
		.ELSE
			Invoke DestroyWindow,hWnd
		.ENDIF
		
	.ELSEIF uMsg==WM_KEYDOWN
		.if wParam==27				; [esc]-key pressed?
			Invoke DestroyWindow, hWnd	; close
		.elseif
			Invoke _KeyProc, wParam
		.endif
		
	.ELSEIF uMsg==WM_LBUTTONDOWN
; --------- change position of navigation cross
		push eax
		Invoke GetClientRect,hWnd,ADDR rctT
		pop eax
		mov eax,lParam
		push eax 
		and eax,0FFFFh				; retrieve x-coordinate
		mov ecx,rctT.right
		shr ecx,1
		sub eax,ecx
		mov udwXoff,eax 
		pop eax 
		shr eax,16					; retrieve y-coordinate
		mov ecx,rctT.bottom
		shr ecx,1
		sub eax,ecx        
		mov udwYoff,eax 
		
	.ELSEIF uMsg==WM_MOUSEWHEEL
; --------- change speed 
		xor eax,eax
		add eax,wParam
		.If SIGN?
			Invoke _KeyProc,107		; value negative == the wheel was rotated backward, toward the user.
		.Elseif
			Invoke _KeyProc,109		; value positive == the wheel was rotated forward, away from the user.
		.Endif
		
	.ELSE
		Invoke DefWindowProc, hWnd, uMsg, wParam, lParam
		RET
	.ENDIF
	XOR EAX,EAX
	RET
WndProc ENDP

END Start
